import { getDict } from '@/hooks/web/useDictionaries'
import commonPath from './conditionFilter/commonPath.vue'

// dictUse: 查数据回显(一维数组字典)，dictShow: 用户操作的字典(用户看到的数据)
// 当type是tree类型的数据的时候需要提供dictType
const dictList = [
  { 
    dictUse: 'menduner_industry_type',
    apiType: 'industryList',
    dictShow: 1,
    key: 'industryIds',
    itemKey: 'id',
    itemText: 'nameCn',
    title: '行业类型',
    isSingle: true,
    path: commonPath,
    data: []
  },
  { 
    dictUse: 'positionData',
    apiType: 'positionData',
    dictShow: 1,
    key: 'positionId',
    itemKey: 'id',
    itemText: 'nameCn',
    title: '职位类型',
    isSingle: true,
    path: commonPath,
    data: []
  },
  { 
    dictShow: 'menduner_job_type',
    key: 'jobType',
    itemKey: 'value',
    itemText: 'label',
    title: '求职类型',
    path: commonPath,
    data: []
  },
  { 
    dictShow: 'menduner_exp_type',
    key: 'expType',
    itemKey: 'value',
    itemText: 'label',
    title: '工作经验',
    path: commonPath,
    data: []
  },
  { 
    dictShow: 'menduner_pay_scope',
    key: 'payType',
    itemKey: 'value',
    itemText: 'label',
    title: '薪资待遇',
    isSingle: true,
    path: commonPath,
    data: []
  },
  { 
    dictShow: 'menduner_education_type',
    key: 'eduType',
    itemKey: 'value',
    itemText: 'label',
    title: '学历要求',
    path: commonPath,
    data: []
  },
  { 
    dictShow: 'menduner_scale',
    key: 'scale',
    itemKey: 'value',
    itemText: 'label',
    title: '公司规模',
    path: commonPath,
    data: []
  },
  { 
    dictShow: 'menduner_financing_status',
    key: 'financingStatus',
    itemKey: 'value',
    itemText: 'label',
    title: '融资阶段',
    path: commonPath,
    data: []
  },
]
export const filterList = dictList

// 字典
const getDictList = async () => {
  dictList.forEach(async (dictListItem) => {
    const dictUse = dictListItem.dictUse || dictListItem.dictShow
    const { data } = await getDict(dictUse, dictListItem.params, dictListItem.apiType)
    dictListItem.data = data
  })
}

const getData = async () => {
  await getDictList()
}
getData()

export const getItemObj = ({ key, ids = [] }) => {
  const item = dictList.find(dictListItem => dictListItem.key === key)
  const checkedItems = ids.map(id => {
    if (!item?.data?.length) return ''
    const obj = item.data.find(e => e[item.itemKey] === id)
    return obj ? { text: obj[item.itemText], value: obj[item.itemKey] } : ''
  }).filter(Boolean)

  return checkedItems?.length ? { key, title: item.title, checkedItems, ref: item.ref } : ''
}